program binserv;

{ A binary data server program. }

uses
   sockets, inetaux, myerror;

const
   ListenPort : Word = $AFFE;
   MaxConn = 1;
   BufSize = 1024;

var
   Buffy : array[0..BufSize - 1] of Char;

procedure FillBuffer;
var i : LongInt;
begin
   for i := 0 to BufSize - 1 do Buffy[i] := Chr(Random(256));
end;

var
   lSock, uSock : LongInt;
   sAddr : TInetSockAddr;
   Len : LongInt;
   Amount : LongInt;

begin
   Randomize;
   
   lSock := Socket(af_inet, sock_stream, 0);
   if lSock = -1 then SockError('Socket: ');
   
   with sAddr do
   begin
      Family := af_inet;
      Port := htons(ListenPort);
      Addr := 0;
   end;
   
   if not Bind(lSock, sAddr, sizeof(sAddr)) then SockError('Bind: ');
   if not Listen(lSock, MaxConn) then SockError('Listen: ');
   
   repeat
      Say('Waiting for connections...');
      Len := sizeof(sAddr);
      uSock := Accept(lSock, sAddr, Len);
      if uSock = -1 then SockError('Accept: ');
      Say('Accepted connection from ' + AddrToStr(sAddr.Addr));
      
      Len := Recv(uSock, Amount, sizeof(Amount), 0);
      if SocketError <> 0 then SockError('Recv: ');
      if Len < sizeof(Amount) then GenError('Couldn''t receive a LongInt!');
      
      while Amount > 0 do
      begin
         FillBuffer;
         if Amount < BufSize then Len := Amount else Len := BufSize;
         Len := Send(uSock, Buffy, Len, 0);
         if Len = -1 then SockError('Send: ');
         Dec(Amount, Len);
      end;

      Shutdown(uSock, 2);
      Say('Connection closed.');
   until False;
end.
