program dtname;

{ Simple client program with DNS support }

uses
   sockets, inet, inetaux, myerror;

const
   RemotePort : Word = 13;

var
   Sock : LongInt;
   sAddr : TInetSockAddr;
   sin, sout : Text;
   Line : String;
   Host : THost;

begin
   if ParamCount = 0 then GenError('Supply hostname as parameter');

   with sAddr do
   begin
      Family := af_inet;
      Port := htons(RemotePort);
      Addr := StrToAddr(ParamStr(1));  { Maybe it's an IP address }
      if Addr = 0 then
      begin
         with Host do
         begin
            NameLookup(ParamStr(1));
            if LastError <> 0 then GenError('Name lookup failure');
            Writeln('Official name: ', Name);
            Addr := LongInt(IPAddress);
            Writeln('IP address: ', AddrToStr(Addr));
         end;
      end;
   end;

   Sock := Socket(af_inet, sock_stream, 0);
   if Sock = -1 then SockError('Socket: ');

   if not Connect(Sock, sAddr, sizeof(sAddr)) then SockError('Connect: ');
   Sock2Text(Sock, sin, sout);
   Reset(sin);
   Rewrite(sout);

   while not eof(sin) do   
   begin
      Readln(sin, Line);
      Writeln(Line);
   end;
   
   Close(sin);
   Close(sout);
   Shutdown(Sock, 2);
end.
