program mtserv;

{ A multi-threaded server program. }

uses
   sockets, inetaux, myerror, linux;

const
   ListenPort : Word = $AFFE;
   MaxConn = 1;

var
   lSock, uSock : LongInt;
   sAddr : TInetSockAddr;
   Len : LongInt;
   Line : String;
   sin, sout : Text;

begin
   lSock := Socket(af_inet, sock_stream, 0);
   if lSock = -1 then SockError('Socket: ');
   
   with sAddr do
   begin
      Family := af_inet;
      Port := htons(ListenPort);
      Addr := 0;
   end;
   
   if not Bind(lSock, sAddr, sizeof(sAddr)) then SockError('Bind: ');
   if not Listen(lSock, MaxConn) then SockError('Listen: ');
   
   repeat
      Say('Waiting for connections...');
      Len := sizeof(sAddr);
      uSock := Accept(lSock, sAddr, Len);
      if uSock = -1 then SockError('Accept: ');
      Say('Accepted connection from ' + AddrToStr(sAddr.Addr));
      
      if Fork = 0 then  { we are the child }
      begin

         Sock2Text(uSock, sin, sout);
      
         Reset(sin);
         Rewrite(sout);
         Writeln(sout, 'Welcome, stranger!');
         while not eof(sin) do
         begin
            Readln(sin, Line);
            if Line = 'close' then break;
            Writeln(sout, Length(Line));
         end;
   
         Close(sin);
         Close(sout);
         Shutdown(uSock, 2);
         Say('Connection closed.');
         Halt;
      end
      else  { we are the parent }
      repeat until WaitPid(-1, nil, wnohang) < 1;
   until False;
end.
